//================================================
// RMS - Monster Size Randomizer Mutator by Mr.Loathsome.
//================================================
class RM expands Mutator config(RMS);

var bool bInit;
var() config bool bDebugMode;
var() config float MinMSize;
var() config float MaxMSize;
var() config float MinMHealth;
var() config float MaxMHealth;
var() config float ScaleDown;
var() config float ReSizeRate;

function PostBeginPlay()
{
	if (bInit) return; else bInit = True;
	if (bDebugMode) log("RMS: Init");
	Super.PostBeginPlay();
	SetTimer(ReSizeRate, True);
}

function Timer()
{
   local Pawn P;

	if (bDebugMode) log("RMS: Timer Monster size check");
	for ( P=Level.PawnList; P!=None; P=P.nextPawn )
	{
		if ((ScriptedPawn(P) != None) && (P.DrawScale == P.default.DrawScale) && (!ScriptedPawn(P).bIsBoss))
		{
			CheckReSize(P);
		}
	}
}

function bool CheckCollision(Actor A, float DSM, vector newLoc)  // Credit to Feralidragon for this function
{
local bool isColliding;
local float CRadius, CHeight;

   CRadius = A.CollisionRadius;
   CHeight = A.CollisionHeight;
   A.SetCollisionSize(A.CollisionRadius * DSM, A.CollisionHeight * DSM);
   isColliding = !A.SetLocation(newLoc);
   A.SetCollisionSize(CRadius, CHeight);
   if (bDebugMode)
   {
       if (isColliding)
          log("RMS: Can NOT grow = "$A$"  DrawScaleMult = "$DSM);
       else
          log("RMS: Can grow = "$A$"  DrawScaleMult = "$DSM);
   }
   return isColliding;
}

function CheckReSize(Actor Other)
{
	local float F;
	local Vector V;

	F = FMax(MinMSize, (FRand()*MaxMSize));
	V = Other.Location;
	if (F > 1.0)
	{
		While ( (F > MinMSize) && (CheckCollision(Other, F, V)) ) 
			{ F = FMax(MinMSize, F - ScaleDown); if (bDebugMode) { log("RMS: Scaledown -> "$F); } }
	}
	Other.DrawScale = Other.DrawScale * F;
	Other.Mass = Other.Mass * F;
	if (ScriptedPawn(Other).Shadow != None)
		{ ScriptedPawn(Other).Shadow.DrawScale = ScriptedPawn(Other).Shadow.DrawScale * F; }
	ScriptedPawn(Other).Health = FClamp(ScriptedPawn(Other).Health * F, MinMHealth, MaxMHealth);
	Other.SetCollisionSize((Other.CollisionRadius * F), (Other.CollisionHeight * F));
	if ((bDebugMode) && (Other.DrawScale != Other.default.DrawScale))
		{ log("RMS: Pawn size randomized.... "$Other$" DrawScale = "$Other.DrawScale$" Health = "$Pawn(Other).Health); }
	if ((bDebugMode) && (Other.DrawScale == Other.default.DrawScale))
		{ log("RMS: Pawn size NOT randomized.... "$Other$" DrawScale = "$Other.DrawScale); }
}

defaultproperties
{
     bDebugMode=False
     MinMSize=0.2500
     MaxMSize=2.0000
     MinMHealth=40.0
     MaxMHealth=3000.0
     ScaleDown=0.2500
     ReSizeRate=20.00
}
